/********************************************************
 * MAT 259 - Winter 2017                                *
 * 2D project                                           *     
 *                                                      *
 * Author: Jingi Xiao                                   *
 * Supervisor: George Legrady                           *
 *                                                      *
 * Purpose: Show the average title length( number of    *
 *          character) in different dewey classes.      *
 *           Try to find something  interesting.        *
 *                                                      *
 * Inspired by sunburst chart.                          *
 ********************************************************/


float centerx, centery, radius;
Sector sect;
Sector[] sectC, sectD, sectS;

String[] filename = {"DeweyClass.csv", "DeweyDivision.csv", "DeweySection.csv"};
Table table;
int numRows;
float[] value1, value2, value3;
int[] Label;

boolean set = false;
int changeD = 100;
String text = "OVERVIEW";
int b=100;

int[] fontColor = {70, 90};
int[] fontSize = {28, 14, 12, 10};

color[][] Clr = {{#C5734F, #C59C44, #C0BE51, #A3C15C, #63CD92, #42C8CA, #63AFCE, #9D97C7, #D38BB7, #CD6D72}, 
  {#DF835A, #DCAF4D, #D3CE59, #BFDC68, #6FE5A4, #4AE0E1, #6DC1E3, #B0AADF, #E59ACC, #E3797F}, 
  {#F89167, #F4C356, #E5DF60, #DDF774, #7AFCB6, #52F8F8, #77D4F8, #C3BDF7, #F7ABE2, #F9858D}};

void setup() {
  size(1080, 720);

  centerx = 400;
  centery = 360;
  radius = 120; 

  ////////////     read data from file ///////////////////////
  for (int i=0; i<3; i++)
  {
    table = loadTable(filename[i], "header");
    numRows = table.getRowCount();
    if (i == 0)
    {
      value1 = new float[numRows];
      sectC = new Sector[numRows];
    }
    if (i == 1)
    {
      value2 = new float[numRows];
      sectD = new Sector[numRows];
    }
    if (i == 2)
    {
      value3 = new float[numRows];
      sectS = new Sector[numRows];
      Label = new int[numRows];
    }

    for (int j=0; j<numRows; j++)
    {
      if (i == 0)
        value1[j] = table.getFloat(j, 1);
      if (i == 1)
        value2[j] = table.getFloat(j, 1);
      if (i == 2)
      {
        value3[j] = table.getFloat(j, 1);
        Label[j] = table.getInt(j, 0);
      }
    }
  }


  // /////////  store data in sectors ///////////////////////
  sect = new Sector(null, "", 1, 0);

  for (int i=0; i<value1.length; i++)
    sectC[i] = sect.addSector(i+"00", value1[i], i);


  for (int i=0; i<value2.length; i++)
  {
    int j = int(i/10);
    sectD[i] = sectC[j].addSector(i+"0", value2[i], sectC[j].clr);
  }

  for (int i=0; i<value3.length; i++)
  {
    int j = int(Label[i]/10);
    sectS[i] = sectD[j].addSector(str(Label[i]), value3[i], sectD[j].clr);
  }


  ////////////////////  calculation part //////////////////
  sect.calculation();

  for (int i=0; i<sect.children.size(); i++)
    sectC[i].calculation();

  for (int i=0; i<sectD.length; i++)
    sectD[i].calculation();
    
    
}



void draw() {
  background(220);
  surface.setResizable(false); 

  ////////////////////// sector ///////////////////////////////////////////


  if (set == false) reset();
  else if (changeD <10) chooseDivison(changeD);
  
  fill(220);
  arc(centerx, centery, 1.5*radius, 1.5*radius, 0, TWO_PI);


  ////////////////////////////// word part /////////////////////////////////
  // title 
  strokeWeight(0.5);
  fill(fontColor[0]);
  textSize(fontSize[0]);
  textAlign(RIGHT, CENTER);
  text("DOES TITLE LENGTH DIFFER?", width-20, 50);

  //subheading
  fill(fontColor[1]);
  textSize(fontSize[2]);
  text("Average Title Length in Different Dewey Classes", width-20, 80);
  text("Data Source: Seattle Public Library", width-20, 95);
  textSize(fontSize[1]);
  text("MAT 259 | JINGYI XIAO", width-20, 120);

  //legend

  fill(fontColor[1]);
  textSize(fontSize[1]); 
  textAlign(RIGHT, CENTER);
  text(text, width-20, 450);

  textSize(fontSize[3]);
  for (int i=0; i<10; i++)
  {
    noStroke();
    fill(Clr[2][i]);
    ellipse(width-50, 471+12*i, 4, 4);
    fill(fontColor[1]);
    textAlign(RIGHT, CENTER);
    text(i+"00", width-20, 470+12*i);
  }

  textSize(fontSize[2]);
  textAlign(RIGHT, CENTER);
  text("Press 0-9, change to single view of Dewey class", width-20, height-70);
  text("Press r or R, change to overview", width-20, height-50);
  text("Hover to see details", width-20, height-30);

  /////////////////  mouse move over sector ////////////////////
   mouseover();
}