// reference: https://www.openprocessing.org/sketch/388902

class Sector {

  //define a sector
  Sector mother;
  String label;
  float value;
  int clr;

  ArrayList<Sector> children= new ArrayList<Sector>();
  ArcSegment[] segments;

  int gen; //generation
  float rstart, rextent; 
  float len; //length

  //constructor
  Sector(Sector mother, String label, float value, int clr) {
    this.mother = mother;
    this.label = label;
    this.value = value;
    this.clr =clr;

    if (mother == null) {
      rstart = 0;
      rextent = TWO_PI;
      gen =0;
      len = 0;
    } else {
      gen = mother.gen + 1;
    }
  } 


  //add 'children' sector to 'mother' sector
  Sector addSector(String label, float value, int clr) {
    Sector child = new Sector(this, label, value, clr);
    children.add(child);
    return child;
  }

  void calculation() {
    float sum = 0;
    for (int i=0; i<children.size(); i++) {
      sum += children.get(i).value;
    }

    children.get(0).rstart = 0;
    children.get(0).rextent = children.get(0).value/ sum;
    for (int i=1; i<children.size(); i++) { 
      children.get(i).rextent = (children.get(i).value/ sum);
      children.get(i).rstart = children.get(i-1).rstart + children.get(i-1).rextent ;
    }
  }


  //// draw the arc
  void createSegments() {
    for (int i=0; i< children.size(); i++) {
        ArcSegment segment = new ArcSegment(children.get(i).rstart, children.get(i).rextent, gen, rstart, rextent, children.get(i).clr);
      segment.render();
    } 
  }
}